/* =====================================================================

   LiMo - Liblary
      Font Display Sample.  - եɽμ¸ץ

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Sep.20.1999  Programing start

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  SampleInit       -- ʤ
  SampleMain       -- ʸɽ롼

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <gtk/gtk.h>
#include  "rr_screen.h"


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* -- ̵Ȥߤ() */
#include "../picture/meet02.xpm"


enum {
  PS_INIT = 0,
  PS_DISP,
  PS_WAIT,
  PS_DISPNEXT,
  PS_CLICKWAIT
};

/* -- ץƥ */

gchar *ttext = 
  "֤ɤá\n\
֤á\n\n\
ξ׷ȤȤˤĤΤ褦ʤΤʹ롣\n\
ʤȤ׷Ѥ\
夽μǧ褦Τִ\n\
\n֤ɤ\n\n\
αĤä";


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- եɽɸ */
gint  fx, fy;

/* --- եȤΥʤ */
gint  fh, fw;

/* --- ץॹƥå */
gint  step;
gint  fntptr;

/* --- ޥå */
gint  click;

/* --- 륿ޡ */
gint  ltimer;

/* --- ߡѿ */
gint  dummy;

/* --- طʥեåʤ */
GdkPixmap *pix;
GdkBitmap *mask;


/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  SampleInit       -- ʤ

   return : void
   void

-------------------------------------------------------------- */
void SampleInit(void)
{
  step = PS_INIT;
  fntptr = 0;
  fx = fy = 10;
  /* Pixmap κ */
  pix = gdk_pixmap_create_from_xpm_d(RRScreenCanvas()->window,
					&mask,
					NULL,
					meet02_xpm);
  /* ̥ꥢ */
  RRScreenPutPixmap(pix, 0, 0);
}


/* -------------------------------------------------------------
  SampleFree       -- λޤ

   return : void
   void

-------------------------------------------------------------- */
void SampleFree(void)
{
  gdk_pixmap_unref(pix);
  gdk_bitmap_unref(mask);
}


/* -------------------------------------------------------------
  SampleClick       -- ɥåޤ

   return : void
   void

-------------------------------------------------------------- */
void SampleClick(void)
{
  click = 1;
}


/* -------------------------------------------------------------
  SampleMain       -- ʸɽ륵ץ

   return : void
   void
-------------------------------------------------------------- */
void SampleMain(void)
{
  gchar  dispfont[3];
  gint  w, h;
  gint  nextflag;

  nextflag = 0;
  while(nextflag == 0) {
    /* --- STEP */
    switch(step) {
    case PS_INIT:
      fx = fy = 10;
      step = PS_DISP;
      break;

    case PS_DISP:
      if (ttext[fntptr] == '\n') {
	fntptr++;
	step = PS_DISPNEXT;
	break;
      }
      /* ʸɽ */
      if ((guchar)ttext[fntptr] < 0x80) {
	dispfont[0] = ttext[fntptr];
	dispfont[1] = 0;
	RRScreenFontSize(dispfont, &w, &h);
	fh = h;
	fw = w;
	RRScreenGCColor(0, 0, 0);
	RRScreenFontLocate(fx-1, fy);
	RRScreenFontPrint(dispfont);
	RRScreenFontLocate(fx+1, fy);
	RRScreenFontPrint(dispfont);
	RRScreenFontLocate(fx, fy-1);
	RRScreenFontPrint(dispfont);
	RRScreenFontLocate(fx, fy+1);
	RRScreenFontPrint(dispfont);
	RRScreenGCColor(0xffff, 0xffff, 0xffff);
	RRScreenFontLocate(fx, fy);
	RRScreenFontPrint(dispfont);
	fx += (w+2);
	fntptr++;
      }
      else {
	dispfont[0] = ttext[fntptr];
	dispfont[1] = ttext[fntptr+1];
	dispfont[2] = 0;
	RRScreenFontSize(dispfont, &w, &h);
	fh = h;
	fw = w;
	RRScreenGCColor(0, 0, 0);
	RRScreenFontLocate(fx-1, fy);
	RRScreenFontPrint(dispfont);
	RRScreenFontLocate(fx+1, fy);
	RRScreenFontPrint(dispfont);
	RRScreenFontLocate(fx, fy-1);
	RRScreenFontPrint(dispfont);
	RRScreenFontLocate(fx, fy+1);
	RRScreenFontPrint(dispfont);
	RRScreenGCColor(0xffff, 0xffff, 0xffff);
	RRScreenFontLocate(fx, fy);
	RRScreenFontPrint(dispfont);
	fx += (w+2);
	fntptr += 2;
      }
      ltimer = 1;
      step = PS_WAIT;
      break;
      
    case PS_WAIT:
      if (ltimer > 0) {
	ltimer--;
	nextflag = 1;
	break;
      }
      step = PS_DISPNEXT;
      break;
      
    case PS_DISPNEXT: 
      /* -- ޤ */
      if (ttext[fntptr] == 0) {
	RRScreenGCColor(0, 0, 0);
	RRScreenFontLocate(fx-1, fy);
	RRScreenFontPrint("");
	RRScreenFontLocate(fx+1, fy);
	RRScreenFontPrint("");
	RRScreenFontLocate(fx, fy-1);
	RRScreenFontPrint("");
	RRScreenFontLocate(fx, fy+1);
	RRScreenFontPrint("");
	RRScreenGCColor(0xffff, 0xffff, 0xffff);
	RRScreenFontLocate(fx, fy);
	RRScreenFontPrint("");
	click = 0;
	fntptr = 0;
	step = PS_CLICKWAIT;
	break;
      }
      /* -- Խ */
      if ((ttext[fntptr] == '\n') || (fx > 300)) {
	fy += (fh * 3 / 2);        /* ľǤ */
	if (fy > 220) {
	  RRScreenGCColor(0, 0, 0);
	  RRScreenFontLocate(fx-1, fy);
	  RRScreenFontPrint("");
	  RRScreenFontLocate(fx+1, fy);
	  RRScreenFontPrint("");
	  RRScreenFontLocate(fx, fy-1);
	  RRScreenFontPrint("");
	  RRScreenFontLocate(fx, fy+1);
	  RRScreenFontPrint("");
	  RRScreenGCColor(0xffff, 0xffff, 0xffff);
	  RRScreenFontLocate(fx, fy);
	  RRScreenFontPrint("");
	  click = 0;
	  step = PS_CLICKWAIT;
	}
	else {
	  fx = 10;
	  step = PS_DISP;
	}
	break;
      }
      step = PS_DISP;
      break;
      
    case PS_CLICKWAIT:
      if (click == 1) {
	/* å줿ΤǼ */
	click = 0;
//        RRScreenClear(0xc000, 0xc000, 0xffff);
	RRScreenPutPixmap(pix, 0, 0);
	step = PS_INIT;
      }
      nextflag = 1;
      break;
    }
  }

  /* --- ʤ󤫴ؿ뤷ʤ˥꥿󤷤ʤΤǥߡ */
  /*     Ϥʤ (;_;) */
  RRScreenFontLocate(fx, fy);
}



